// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acl

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v2/models"
)

// GetACLOKCode is the HTTP code returned for type GetACLOK
const GetACLOKCode int = 200

/*GetACLOK Successful operation

swagger:response getAclOK
*/
type GetACLOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *GetACLOKBody `json:"body,omitempty"`
}

// NewGetACLOK creates GetACLOK with default headers values
func NewGetACLOK() *GetACLOK {

	return &GetACLOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Acl o k response
func (o *GetACLOK) WithConfigurationVersion(configurationVersion string) *GetACLOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Acl o k response
func (o *GetACLOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Acl o k response
func (o *GetACLOK) WithPayload(payload *GetACLOKBody) *GetACLOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Acl o k response
func (o *GetACLOK) SetPayload(payload *GetACLOKBody) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetACLOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetACLNotFoundCode is the HTTP code returned for type GetACLNotFound
const GetACLNotFoundCode int = 404

/*GetACLNotFound The specified resource was not found

swagger:response getAclNotFound
*/
type GetACLNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetACLNotFound creates GetACLNotFound with default headers values
func NewGetACLNotFound() *GetACLNotFound {

	return &GetACLNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get Acl not found response
func (o *GetACLNotFound) WithConfigurationVersion(configurationVersion string) *GetACLNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Acl not found response
func (o *GetACLNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Acl not found response
func (o *GetACLNotFound) WithPayload(payload *models.Error) *GetACLNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Acl not found response
func (o *GetACLNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetACLNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetACLDefault General Error

swagger:response getAclDefault
*/
type GetACLDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetACLDefault creates GetACLDefault with default headers values
func NewGetACLDefault(code int) *GetACLDefault {
	if code <= 0 {
		code = 500
	}

	return &GetACLDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get Acl default response
func (o *GetACLDefault) WithStatusCode(code int) *GetACLDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get Acl default response
func (o *GetACLDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get Acl default response
func (o *GetACLDefault) WithConfigurationVersion(configurationVersion string) *GetACLDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Acl default response
func (o *GetACLDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Acl default response
func (o *GetACLDefault) WithPayload(payload *models.Error) *GetACLDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Acl default response
func (o *GetACLDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetACLDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
