// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package backend

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/haproxytech/client-native/v2/models"
)

// GetBackendsHandlerFunc turns a function with the right signature into a get backends handler
type GetBackendsHandlerFunc func(GetBackendsParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetBackendsHandlerFunc) Handle(params GetBackendsParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetBackendsHandler interface for that can handle valid get backends params
type GetBackendsHandler interface {
	Handle(GetBackendsParams, interface{}) middleware.Responder
}

// NewGetBackends creates a new http.Handler for the get backends operation
func NewGetBackends(ctx *middleware.Context, handler GetBackendsHandler) *GetBackends {
	return &GetBackends{Context: ctx, Handler: handler}
}

/*GetBackends swagger:route GET /services/haproxy/configuration/backends Backend getBackends

Return an array of backends

Returns an array of all configured backends.

*/
type GetBackends struct {
	Context *middleware.Context
	Handler GetBackendsHandler
}

func (o *GetBackends) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetBackendsParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetBackendsOKBody get backends o k body
//
// swagger:model GetBackendsOKBody
type GetBackendsOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data models.Backends `json:"data"`
}

// Validate validates this get backends o k body
func (o *GetBackendsOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetBackendsOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getBackendsOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	if err := o.Data.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("getBackendsOK" + "." + "data")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetBackendsOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetBackendsOKBody) UnmarshalBinary(b []byte) error {
	var res GetBackendsOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
