// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package backend_switching_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/haproxytech/client-native/v2/models"
)

// GetBackendSwitchingRulesHandlerFunc turns a function with the right signature into a get backend switching rules handler
type GetBackendSwitchingRulesHandlerFunc func(GetBackendSwitchingRulesParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetBackendSwitchingRulesHandlerFunc) Handle(params GetBackendSwitchingRulesParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetBackendSwitchingRulesHandler interface for that can handle valid get backend switching rules params
type GetBackendSwitchingRulesHandler interface {
	Handle(GetBackendSwitchingRulesParams, interface{}) middleware.Responder
}

// NewGetBackendSwitchingRules creates a new http.Handler for the get backend switching rules operation
func NewGetBackendSwitchingRules(ctx *middleware.Context, handler GetBackendSwitchingRulesHandler) *GetBackendSwitchingRules {
	return &GetBackendSwitchingRules{Context: ctx, Handler: handler}
}

/*GetBackendSwitchingRules swagger:route GET /services/haproxy/configuration/backend_switching_rules BackendSwitchingRule getBackendSwitchingRules

Return an array of all Backend Switching Rules

Returns all Backend Switching Rules that are configured in specified frontend.

*/
type GetBackendSwitchingRules struct {
	Context *middleware.Context
	Handler GetBackendSwitchingRulesHandler
}

func (o *GetBackendSwitchingRules) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetBackendSwitchingRulesParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetBackendSwitchingRulesOKBody get backend switching rules o k body
//
// swagger:model GetBackendSwitchingRulesOKBody
type GetBackendSwitchingRulesOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data models.BackendSwitchingRules `json:"data"`
}

// Validate validates this get backend switching rules o k body
func (o *GetBackendSwitchingRulesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetBackendSwitchingRulesOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getBackendSwitchingRulesOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	if err := o.Data.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("getBackendSwitchingRulesOK" + "." + "data")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetBackendSwitchingRulesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetBackendSwitchingRulesOKBody) UnmarshalBinary(b []byte) error {
	var res GetBackendSwitchingRulesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
