// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package configuration

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// GetHAProxyConfigurationHandlerFunc turns a function with the right signature into a get h a proxy configuration handler
type GetHAProxyConfigurationHandlerFunc func(GetHAProxyConfigurationParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetHAProxyConfigurationHandlerFunc) Handle(params GetHAProxyConfigurationParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetHAProxyConfigurationHandler interface for that can handle valid get h a proxy configuration params
type GetHAProxyConfigurationHandler interface {
	Handle(GetHAProxyConfigurationParams, interface{}) middleware.Responder
}

// NewGetHAProxyConfiguration creates a new http.Handler for the get h a proxy configuration operation
func NewGetHAProxyConfiguration(ctx *middleware.Context, handler GetHAProxyConfigurationHandler) *GetHAProxyConfiguration {
	return &GetHAProxyConfiguration{Context: ctx, Handler: handler}
}

/*GetHAProxyConfiguration swagger:route GET /services/haproxy/configuration/raw Configuration getHAProxyConfiguration

Return HAProxy configuration

Returns HAProxy configuration file in plain text

*/
type GetHAProxyConfiguration struct {
	Context *middleware.Context
	Handler GetHAProxyConfigurationHandler
}

func (o *GetHAProxyConfiguration) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetHAProxyConfigurationParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetHAProxyConfigurationOKBody get h a proxy configuration o k body
//
// swagger:model GetHAProxyConfigurationOKBody
type GetHAProxyConfigurationOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data *string `json:"data"`
}

// Validate validates this get h a proxy configuration o k body
func (o *GetHAProxyConfigurationOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetHAProxyConfigurationOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getHAProxyConfigurationOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetHAProxyConfigurationOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetHAProxyConfigurationOKBody) UnmarshalBinary(b []byte) error {
	var res GetHAProxyConfigurationOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
