// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package filter

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v2/models"
)

// DeleteFilterAcceptedCode is the HTTP code returned for type DeleteFilterAccepted
const DeleteFilterAcceptedCode int = 202

/*DeleteFilterAccepted Configuration change accepted and reload requested

swagger:response deleteFilterAccepted
*/
type DeleteFilterAccepted struct {
	/*ID of the requested reload

	 */
	ReloadID string `json:"Reload-ID"`
}

// NewDeleteFilterAccepted creates DeleteFilterAccepted with default headers values
func NewDeleteFilterAccepted() *DeleteFilterAccepted {

	return &DeleteFilterAccepted{}
}

// WithReloadID adds the reloadId to the delete filter accepted response
func (o *DeleteFilterAccepted) WithReloadID(reloadID string) *DeleteFilterAccepted {
	o.ReloadID = reloadID
	return o
}

// SetReloadID sets the reloadId to the delete filter accepted response
func (o *DeleteFilterAccepted) SetReloadID(reloadID string) {
	o.ReloadID = reloadID
}

// WriteResponse to the client
func (o *DeleteFilterAccepted) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Reload-ID

	reloadID := o.ReloadID
	if reloadID != "" {
		rw.Header().Set("Reload-ID", reloadID)
	}

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(202)
}

// DeleteFilterNoContentCode is the HTTP code returned for type DeleteFilterNoContent
const DeleteFilterNoContentCode int = 204

/*DeleteFilterNoContent Filter deleted

swagger:response deleteFilterNoContent
*/
type DeleteFilterNoContent struct {
}

// NewDeleteFilterNoContent creates DeleteFilterNoContent with default headers values
func NewDeleteFilterNoContent() *DeleteFilterNoContent {

	return &DeleteFilterNoContent{}
}

// WriteResponse to the client
func (o *DeleteFilterNoContent) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.Header().Del(runtime.HeaderContentType) //Remove Content-Type on empty responses

	rw.WriteHeader(204)
}

// DeleteFilterNotFoundCode is the HTTP code returned for type DeleteFilterNotFound
const DeleteFilterNotFoundCode int = 404

/*DeleteFilterNotFound The specified resource was not found

swagger:response deleteFilterNotFound
*/
type DeleteFilterNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteFilterNotFound creates DeleteFilterNotFound with default headers values
func NewDeleteFilterNotFound() *DeleteFilterNotFound {

	return &DeleteFilterNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the delete filter not found response
func (o *DeleteFilterNotFound) WithConfigurationVersion(configurationVersion string) *DeleteFilterNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete filter not found response
func (o *DeleteFilterNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete filter not found response
func (o *DeleteFilterNotFound) WithPayload(payload *models.Error) *DeleteFilterNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete filter not found response
func (o *DeleteFilterNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFilterNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*DeleteFilterDefault General Error

swagger:response deleteFilterDefault
*/
type DeleteFilterDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewDeleteFilterDefault creates DeleteFilterDefault with default headers values
func NewDeleteFilterDefault(code int) *DeleteFilterDefault {
	if code <= 0 {
		code = 500
	}

	return &DeleteFilterDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the delete filter default response
func (o *DeleteFilterDefault) WithStatusCode(code int) *DeleteFilterDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the delete filter default response
func (o *DeleteFilterDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the delete filter default response
func (o *DeleteFilterDefault) WithConfigurationVersion(configurationVersion string) *DeleteFilterDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the delete filter default response
func (o *DeleteFilterDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the delete filter default response
func (o *DeleteFilterDefault) WithPayload(payload *models.Error) *DeleteFilterDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the delete filter default response
func (o *DeleteFilterDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *DeleteFilterDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
