// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package frontend

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ReplaceFrontendHandlerFunc turns a function with the right signature into a replace frontend handler
type ReplaceFrontendHandlerFunc func(ReplaceFrontendParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn ReplaceFrontendHandlerFunc) Handle(params ReplaceFrontendParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// ReplaceFrontendHandler interface for that can handle valid replace frontend params
type ReplaceFrontendHandler interface {
	Handle(ReplaceFrontendParams, interface{}) middleware.Responder
}

// NewReplaceFrontend creates a new http.Handler for the replace frontend operation
func NewReplaceFrontend(ctx *middleware.Context, handler ReplaceFrontendHandler) *ReplaceFrontend {
	return &ReplaceFrontend{Context: ctx, Handler: handler}
}

/*ReplaceFrontend swagger:route PUT /services/haproxy/configuration/frontends/{name} Frontend replaceFrontend

Replace a frontend

Replaces a frontend configuration by it's name.

*/
type ReplaceFrontend struct {
	Context *middleware.Context
	Handler ReplaceFrontendHandler
}

func (o *ReplaceFrontend) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewReplaceFrontendParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
