// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package global

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ReplaceGlobalHandlerFunc turns a function with the right signature into a replace global handler
type ReplaceGlobalHandlerFunc func(ReplaceGlobalParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn ReplaceGlobalHandlerFunc) Handle(params ReplaceGlobalParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// ReplaceGlobalHandler interface for that can handle valid replace global params
type ReplaceGlobalHandler interface {
	Handle(ReplaceGlobalParams, interface{}) middleware.Responder
}

// NewReplaceGlobal creates a new http.Handler for the replace global operation
func NewReplaceGlobal(ctx *middleware.Context, handler ReplaceGlobalHandler) *ReplaceGlobal {
	return &ReplaceGlobal{Context: ctx, Handler: handler}
}

/*ReplaceGlobal swagger:route PUT /services/haproxy/configuration/global Global replaceGlobal

Replace global

Replace global part of config

*/
type ReplaceGlobal struct {
	Context *middleware.Context
	Handler ReplaceGlobalHandler
}

func (o *ReplaceGlobal) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewReplaceGlobalParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
