// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v2/models"
)

// GetHTTPRequestRulesOKCode is the HTTP code returned for type GetHTTPRequestRulesOK
const GetHTTPRequestRulesOKCode int = 200

/*GetHTTPRequestRulesOK Successful operation

swagger:response getHttpRequestRulesOK
*/
type GetHTTPRequestRulesOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *GetHTTPRequestRulesOKBody `json:"body,omitempty"`
}

// NewGetHTTPRequestRulesOK creates GetHTTPRequestRulesOK with default headers values
func NewGetHTTPRequestRulesOK() *GetHTTPRequestRulesOK {

	return &GetHTTPRequestRulesOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http request rules o k response
func (o *GetHTTPRequestRulesOK) WithConfigurationVersion(configurationVersion string) *GetHTTPRequestRulesOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http request rules o k response
func (o *GetHTTPRequestRulesOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http request rules o k response
func (o *GetHTTPRequestRulesOK) WithPayload(payload *GetHTTPRequestRulesOKBody) *GetHTTPRequestRulesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http request rules o k response
func (o *GetHTTPRequestRulesOK) SetPayload(payload *GetHTTPRequestRulesOKBody) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPRequestRulesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetHTTPRequestRulesDefault General Error

swagger:response getHttpRequestRulesDefault
*/
type GetHTTPRequestRulesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPRequestRulesDefault creates GetHTTPRequestRulesDefault with default headers values
func NewGetHTTPRequestRulesDefault(code int) *GetHTTPRequestRulesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetHTTPRequestRulesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get HTTP request rules default response
func (o *GetHTTPRequestRulesDefault) WithStatusCode(code int) *GetHTTPRequestRulesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get HTTP request rules default response
func (o *GetHTTPRequestRulesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get HTTP request rules default response
func (o *GetHTTPRequestRulesDefault) WithConfigurationVersion(configurationVersion string) *GetHTTPRequestRulesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get HTTP request rules default response
func (o *GetHTTPRequestRulesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get HTTP request rules default response
func (o *GetHTTPRequestRulesDefault) WithPayload(payload *models.Error) *GetHTTPRequestRulesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get HTTP request rules default response
func (o *GetHTTPRequestRulesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPRequestRulesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
