// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package maps

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// AddMapEntryHandlerFunc turns a function with the right signature into a add map entry handler
type AddMapEntryHandlerFunc func(AddMapEntryParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn AddMapEntryHandlerFunc) Handle(params AddMapEntryParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// AddMapEntryHandler interface for that can handle valid add map entry params
type AddMapEntryHandler interface {
	Handle(AddMapEntryParams, interface{}) middleware.Responder
}

// NewAddMapEntry creates a new http.Handler for the add map entry operation
func NewAddMapEntry(ctx *middleware.Context, handler AddMapEntryHandler) *AddMapEntry {
	return &AddMapEntry{Context: ctx, Handler: handler}
}

/*AddMapEntry swagger:route POST /services/haproxy/runtime/maps_entries Maps addMapEntry

Adds an entry into the map file

Adds an entry into the map file.

*/
type AddMapEntry struct {
	Context *middleware.Context
	Handler AddMapEntryHandler
}

func (o *AddMapEntry) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAddMapEntryParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
