// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package maps

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// GetRuntimeMapEntryHandlerFunc turns a function with the right signature into a get runtime map entry handler
type GetRuntimeMapEntryHandlerFunc func(GetRuntimeMapEntryParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetRuntimeMapEntryHandlerFunc) Handle(params GetRuntimeMapEntryParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetRuntimeMapEntryHandler interface for that can handle valid get runtime map entry params
type GetRuntimeMapEntryHandler interface {
	Handle(GetRuntimeMapEntryParams, interface{}) middleware.Responder
}

// NewGetRuntimeMapEntry creates a new http.Handler for the get runtime map entry operation
func NewGetRuntimeMapEntry(ctx *middleware.Context, handler GetRuntimeMapEntryHandler) *GetRuntimeMapEntry {
	return &GetRuntimeMapEntry{Context: ctx, Handler: handler}
}

/*GetRuntimeMapEntry swagger:route GET /services/haproxy/runtime/maps_entries/{id} Maps getRuntimeMapEntry

Return one map runtime setting

Returns one map runtime setting by it's id.

*/
type GetRuntimeMapEntry struct {
	Context *middleware.Context
	Handler GetRuntimeMapEntryHandler
}

func (o *GetRuntimeMapEntry) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetRuntimeMapEntryParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
