// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package peer

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/haproxytech/client-native/v2/models"
)

// GetPeerSectionHandlerFunc turns a function with the right signature into a get peer section handler
type GetPeerSectionHandlerFunc func(GetPeerSectionParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetPeerSectionHandlerFunc) Handle(params GetPeerSectionParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetPeerSectionHandler interface for that can handle valid get peer section params
type GetPeerSectionHandler interface {
	Handle(GetPeerSectionParams, interface{}) middleware.Responder
}

// NewGetPeerSection creates a new http.Handler for the get peer section operation
func NewGetPeerSection(ctx *middleware.Context, handler GetPeerSectionHandler) *GetPeerSection {
	return &GetPeerSection{Context: ctx, Handler: handler}
}

/*GetPeerSection swagger:route GET /services/haproxy/configuration/peer_section/{name} Peer getPeerSection

Return a peer

Returns one peer configuration by it's name.

*/
type GetPeerSection struct {
	Context *middleware.Context
	Handler GetPeerSectionHandler
}

func (o *GetPeerSection) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetPeerSectionParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetPeerSectionOKBody get peer section o k body
//
// swagger:model GetPeerSectionOKBody
type GetPeerSectionOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	Data *models.PeerSection `json:"data,omitempty"`
}

// Validate validates this get peer section o k body
func (o *GetPeerSectionOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetPeerSectionOKBody) validateData(formats strfmt.Registry) error {

	if swag.IsZero(o.Data) { // not required
		return nil
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getPeerSectionOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetPeerSectionOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetPeerSectionOKBody) UnmarshalBinary(b []byte) error {
	var res GetPeerSectionOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
