// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package server

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/haproxytech/client-native/v2/models"
)

// GetServerHandlerFunc turns a function with the right signature into a get server handler
type GetServerHandlerFunc func(GetServerParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetServerHandlerFunc) Handle(params GetServerParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetServerHandler interface for that can handle valid get server params
type GetServerHandler interface {
	Handle(GetServerParams, interface{}) middleware.Responder
}

// NewGetServer creates a new http.Handler for the get server operation
func NewGetServer(ctx *middleware.Context, handler GetServerHandler) *GetServer {
	return &GetServer{Context: ctx, Handler: handler}
}

/*GetServer swagger:route GET /services/haproxy/configuration/servers/{name} Server getServer

Return one server

Returns one server configuration by it's name in the specified backend.

*/
type GetServer struct {
	Context *middleware.Context
	Handler GetServerHandler
}

func (o *GetServer) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetServerParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetServerOKBody get server o k body
//
// swagger:model GetServerOKBody
type GetServerOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	Data *models.Server `json:"data,omitempty"`
}

// Validate validates this get server o k body
func (o *GetServerOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetServerOKBody) validateData(formats strfmt.Registry) error {

	if swag.IsZero(o.Data) { // not required
		return nil
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getServerOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetServerOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetServerOKBody) UnmarshalBinary(b []byte) error {
	var res GetServerOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
