// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package server

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ReplaceRuntimeServerHandlerFunc turns a function with the right signature into a replace runtime server handler
type ReplaceRuntimeServerHandlerFunc func(ReplaceRuntimeServerParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn ReplaceRuntimeServerHandlerFunc) Handle(params ReplaceRuntimeServerParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// ReplaceRuntimeServerHandler interface for that can handle valid replace runtime server params
type ReplaceRuntimeServerHandler interface {
	Handle(ReplaceRuntimeServerParams, interface{}) middleware.Responder
}

// NewReplaceRuntimeServer creates a new http.Handler for the replace runtime server operation
func NewReplaceRuntimeServer(ctx *middleware.Context, handler ReplaceRuntimeServerHandler) *ReplaceRuntimeServer {
	return &ReplaceRuntimeServer{Context: ctx, Handler: handler}
}

/*ReplaceRuntimeServer swagger:route PUT /services/haproxy/runtime/servers/{name} Server replaceRuntimeServer

Replace server transient settings

Replaces a server transient settings by it's name in the specified backend.

*/
type ReplaceRuntimeServer struct {
	Context *middleware.Context
	Handler ReplaceRuntimeServerHandler
}

func (o *ReplaceRuntimeServer) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewReplaceRuntimeServerParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
