// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package server_template

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// CreateServerTemplateHandlerFunc turns a function with the right signature into a create server template handler
type CreateServerTemplateHandlerFunc func(CreateServerTemplateParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn CreateServerTemplateHandlerFunc) Handle(params CreateServerTemplateParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// CreateServerTemplateHandler interface for that can handle valid create server template params
type CreateServerTemplateHandler interface {
	Handle(CreateServerTemplateParams, interface{}) middleware.Responder
}

// NewCreateServerTemplate creates a new http.Handler for the create server template operation
func NewCreateServerTemplate(ctx *middleware.Context, handler CreateServerTemplateHandler) *CreateServerTemplate {
	return &CreateServerTemplate{Context: ctx, Handler: handler}
}

/*CreateServerTemplate swagger:route POST /services/haproxy/configuration/server_templates ServerTemplate createServerTemplate

Add a new server template

Adds a new server template in the specified backend in the configuration file.

*/
type CreateServerTemplate struct {
	Context *middleware.Context
	Handler CreateServerTemplateHandler
}

func (o *CreateServerTemplate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewCreateServerTemplateParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
