// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package server_template

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/haproxytech/client-native/v2/models"
)

// GetServerTemplateHandlerFunc turns a function with the right signature into a get server template handler
type GetServerTemplateHandlerFunc func(GetServerTemplateParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetServerTemplateHandlerFunc) Handle(params GetServerTemplateParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetServerTemplateHandler interface for that can handle valid get server template params
type GetServerTemplateHandler interface {
	Handle(GetServerTemplateParams, interface{}) middleware.Responder
}

// NewGetServerTemplate creates a new http.Handler for the get server template operation
func NewGetServerTemplate(ctx *middleware.Context, handler GetServerTemplateHandler) *GetServerTemplate {
	return &GetServerTemplate{Context: ctx, Handler: handler}
}

/*GetServerTemplate swagger:route GET /services/haproxy/configuration/server_templates/{prefix} ServerTemplate getServerTemplate

Return one server template

Returns one server template configuration by it's prefix in the specified backend.

*/
type GetServerTemplate struct {
	Context *middleware.Context
	Handler GetServerTemplateHandler
}

func (o *GetServerTemplate) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetServerTemplateParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetServerTemplateOKBody get server template o k body
//
// swagger:model GetServerTemplateOKBody
type GetServerTemplateOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	Data *models.ServerTemplate `json:"data,omitempty"`
}

// Validate validates this get server template o k body
func (o *GetServerTemplateOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetServerTemplateOKBody) validateData(formats strfmt.Registry) error {

	if swag.IsZero(o.Data) { // not required
		return nil
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getServerTemplateOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetServerTemplateOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetServerTemplateOKBody) UnmarshalBinary(b []byte) error {
	var res GetServerTemplateOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
