// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package service_discovery

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// CreateConsulHandlerFunc turns a function with the right signature into a create consul handler
type CreateConsulHandlerFunc func(CreateConsulParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn CreateConsulHandlerFunc) Handle(params CreateConsulParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// CreateConsulHandler interface for that can handle valid create consul params
type CreateConsulHandler interface {
	Handle(CreateConsulParams, interface{}) middleware.Responder
}

// NewCreateConsul creates a new http.Handler for the create consul operation
func NewCreateConsul(ctx *middleware.Context, handler CreateConsulHandler) *CreateConsul {
	return &CreateConsul{Context: ctx, Handler: handler}
}

/*CreateConsul swagger:route POST /service_discovery/consul ServiceDiscovery createConsul

Add a new Consul server

Adds a new Consul server.

*/
type CreateConsul struct {
	Context *middleware.Context
	Handler CreateConsulHandler
}

func (o *CreateConsul) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewCreateConsulParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
