// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package sites

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/haproxytech/client-native/v2/models"
)

// GetSitesHandlerFunc turns a function with the right signature into a get sites handler
type GetSitesHandlerFunc func(GetSitesParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetSitesHandlerFunc) Handle(params GetSitesParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetSitesHandler interface for that can handle valid get sites params
type GetSitesHandler interface {
	Handle(GetSitesParams, interface{}) middleware.Responder
}

// NewGetSites creates a new http.Handler for the get sites operation
func NewGetSites(ctx *middleware.Context, handler GetSitesHandler) *GetSites {
	return &GetSites{Context: ctx, Handler: handler}
}

/*GetSites swagger:route GET /services/haproxy/sites Sites getSites

Return an array of sites

Returns an array of all configured sites.

*/
type GetSites struct {
	Context *middleware.Context
	Handler GetSitesHandler
}

func (o *GetSites) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetSitesParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetSitesOKBody get sites o k body
//
// swagger:model GetSitesOKBody
type GetSitesOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data models.Sites `json:"data"`
}

// Validate validates this get sites o k body
func (o *GetSitesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetSitesOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getSitesOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	if err := o.Data.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("getSitesOK" + "." + "data")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetSitesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetSitesOKBody) UnmarshalBinary(b []byte) error {
	var res GetSitesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
