// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package spoe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/haproxytech/client-native/v2/models"
)

// GetSpoeAgentHandlerFunc turns a function with the right signature into a get spoe agent handler
type GetSpoeAgentHandlerFunc func(GetSpoeAgentParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetSpoeAgentHandlerFunc) Handle(params GetSpoeAgentParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetSpoeAgentHandler interface for that can handle valid get spoe agent params
type GetSpoeAgentHandler interface {
	Handle(GetSpoeAgentParams, interface{}) middleware.Responder
}

// NewGetSpoeAgent creates a new http.Handler for the get spoe agent operation
func NewGetSpoeAgent(ctx *middleware.Context, handler GetSpoeAgentHandler) *GetSpoeAgent {
	return &GetSpoeAgent{Context: ctx, Handler: handler}
}

/*GetSpoeAgent swagger:route GET /services/haproxy/spoe/spoe_agents/{name} Spoe getSpoeAgent

Return a spoe agent

Returns one spoe agent configuration in one SPOE scope.

*/
type GetSpoeAgent struct {
	Context *middleware.Context
	Handler GetSpoeAgentHandler
}

func (o *GetSpoeAgent) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetSpoeAgentParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetSpoeAgentOKBody get spoe agent o k body
//
// swagger:model GetSpoeAgentOKBody
type GetSpoeAgentOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data *models.SpoeAgent `json:"data"`
}

// Validate validates this get spoe agent o k body
func (o *GetSpoeAgentOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetSpoeAgentOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getSpoeAgentOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getSpoeAgentOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetSpoeAgentOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetSpoeAgentOKBody) UnmarshalBinary(b []byte) error {
	var res GetSpoeAgentOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
