// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package spoe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/haproxytech/client-native/v2/models"
)

// GetSpoeGroupHandlerFunc turns a function with the right signature into a get spoe group handler
type GetSpoeGroupHandlerFunc func(GetSpoeGroupParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetSpoeGroupHandlerFunc) Handle(params GetSpoeGroupParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetSpoeGroupHandler interface for that can handle valid get spoe group params
type GetSpoeGroupHandler interface {
	Handle(GetSpoeGroupParams, interface{}) middleware.Responder
}

// NewGetSpoeGroup creates a new http.Handler for the get spoe group operation
func NewGetSpoeGroup(ctx *middleware.Context, handler GetSpoeGroupHandler) *GetSpoeGroup {
	return &GetSpoeGroup{Context: ctx, Handler: handler}
}

/*GetSpoeGroup swagger:route GET /services/haproxy/spoe/spoe_groups/{name} Spoe getSpoeGroup

Return a SPOE groups

Returns one SPOE groups configuration in one SPOE scope.

*/
type GetSpoeGroup struct {
	Context *middleware.Context
	Handler GetSpoeGroupHandler
}

func (o *GetSpoeGroup) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewGetSpoeGroupParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// GetSpoeGroupOKBody get spoe group o k body
//
// swagger:model GetSpoeGroupOKBody
type GetSpoeGroupOKBody struct {

	// version
	Version int64 `json:"_version,omitempty"`

	// data
	// Required: true
	Data *models.SpoeGroup `json:"data"`
}

// Validate validates this get spoe group o k body
func (o *GetSpoeGroupOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateData(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetSpoeGroupOKBody) validateData(formats strfmt.Registry) error {

	if err := validate.Required("getSpoeGroupOK"+"."+"data", "body", o.Data); err != nil {
		return err
	}

	if o.Data != nil {
		if err := o.Data.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("getSpoeGroupOK" + "." + "data")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetSpoeGroupOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetSpoeGroupOKBody) UnmarshalBinary(b []byte) error {
	var res GetSpoeGroupOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
