// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package stick_table

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetStickTablesParams creates a new GetStickTablesParams object
// no default values defined in spec.
func NewGetStickTablesParams() GetStickTablesParams {

	return GetStickTablesParams{}
}

// GetStickTablesParams contains all the bound params for the get stick tables operation
// typically these are obtained from a http.Request
//
// swagger:parameters getStickTables
type GetStickTablesParams struct {

	// HTTP Request Object
	HTTPRequest *http.Request `json:"-"`

	/*Process number if master-worker mode, if not all processes are returned
	  In: query
	*/
	Process *int64
}

// BindRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls.
//
// To ensure default values, the struct must have been initialized with NewGetStickTablesParams() beforehand.
func (o *GetStickTablesParams) BindRequest(r *http.Request, route *middleware.MatchedRoute) error {
	var res []error

	o.HTTPRequest = r

	qs := runtime.Values(r.URL.Query())

	qProcess, qhkProcess, _ := qs.GetOK("process")
	if err := o.bindProcess(qProcess, qhkProcess, route.Formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindProcess binds and validates parameter Process from query.
func (o *GetStickTablesParams) bindProcess(rawData []string, hasKey bool, formats strfmt.Registry) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	// Required: false
	// AllowEmptyValue: false
	if raw == "" { // empty values pass all other validations
		return nil
	}

	value, err := swag.ConvertInt64(raw)
	if err != nil {
		return errors.InvalidType("process", "query", "int64", raw)
	}
	o.Process = &value

	return nil
}
