// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package tcp_response_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v2/models"
)

// GetTCPResponseRulesOKCode is the HTTP code returned for type GetTCPResponseRulesOK
const GetTCPResponseRulesOKCode int = 200

/*GetTCPResponseRulesOK Successful operation

swagger:response getTcpResponseRulesOK
*/
type GetTCPResponseRulesOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *GetTCPResponseRulesOKBody `json:"body,omitempty"`
}

// NewGetTCPResponseRulesOK creates GetTCPResponseRulesOK with default headers values
func NewGetTCPResponseRulesOK() *GetTCPResponseRulesOK {

	return &GetTCPResponseRulesOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Tcp response rules o k response
func (o *GetTCPResponseRulesOK) WithConfigurationVersion(configurationVersion string) *GetTCPResponseRulesOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Tcp response rules o k response
func (o *GetTCPResponseRulesOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Tcp response rules o k response
func (o *GetTCPResponseRulesOK) WithPayload(payload *GetTCPResponseRulesOKBody) *GetTCPResponseRulesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Tcp response rules o k response
func (o *GetTCPResponseRulesOK) SetPayload(payload *GetTCPResponseRulesOKBody) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPResponseRulesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*GetTCPResponseRulesDefault General Error

swagger:response getTcpResponseRulesDefault
*/
type GetTCPResponseRulesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetTCPResponseRulesDefault creates GetTCPResponseRulesDefault with default headers values
func NewGetTCPResponseRulesDefault(code int) *GetTCPResponseRulesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetTCPResponseRulesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get TCP response rules default response
func (o *GetTCPResponseRulesDefault) WithStatusCode(code int) *GetTCPResponseRulesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get TCP response rules default response
func (o *GetTCPResponseRulesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get TCP response rules default response
func (o *GetTCPResponseRulesDefault) WithConfigurationVersion(configurationVersion string) *GetTCPResponseRulesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get TCP response rules default response
func (o *GetTCPResponseRulesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get TCP response rules default response
func (o *GetTCPResponseRulesDefault) WithPayload(payload *models.Error) *GetTCPResponseRulesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get TCP response rules default response
func (o *GetTCPResponseRulesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetTCPResponseRulesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
